<template>
    <div class="container">
        <h2 class="text-center">Add/Edit your product here</h2>

        <form @submit.prevent="onSubmit">

            <div class="form-group">
                <label for="title">Product Name</label>
                <input class="form-control"
                       id="title"
                       type="text"
                       placeholder="Enter Product Name"
                       v-model="productName"
                       @blur="$v.productName.$touch()"
                       :class="{'is-invalid': $v.productName.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.productName.required">
                            Please enter the product name.
                        </span>
                        <span v-if="!$v.productName.minLen">
                            Product name must be greater than 5 characters.
                        </span>
                </span>
            </div>

            <div class="form-group">
                <label for="content">Description</label>
                <textarea class="form-control"
                          id="content"
                          rows="3"
                          @blur="$v.description.$touch()"
                          :class="{'is-invalid': $v.description.$error}"
                          v-model="description"></textarea>
                <span class="invalid-feedback">
                        <span v-if="!$v.description.required">
                            Please enter the description.
                        </span>
                </span>
            </div>

            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <span class="input-group-text">Rs.</span>
                </div>
                <input type="number"
                       class="form-control"
                       aria-label="Amount (to the nearest rupees)" placeholder="Enter Price"
                       @blur="$v.price.$touch()"
                       :class="{'is-invalid': $v.price.$error}"
                       v-model="price"/>
                <div class="input-group-append">
                    <span class="input-group-text">.00</span>
                </div>
                <span class="invalid-feedback">
                        <span v-if="!$v.price.required">
                            Please enter the price.
                        </span>
                         <span v-if="!$v.price.maxVal">
                            Only products costing less than Rs 5,00,000 can be added.
                        </span>
                </span>
            </div>

            <div class="form-group">
                <label for="image">Upload Image</label>
                <input id="image"
                       type="file"
                       class="form-control-file"
                       @change="onFileSelect($event)"/>
            </div>

            <button class="btn btn-primary"
                    type="submit"
                    style="width:80px">
                Save
            </button>
        </form>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import { required, minLength, maxValue } from 'vuelidate/lib/validators';
    import axios from "axios";

    export default {
        data() {
            return {
                productName: '',
                description: '',
                price: null,
                image: '',
                status: 'publish'
            }
        },
        validations: {
          productName: {
              required,
              minLen: minLength(5)
          },
          description: {
              required
          },
          price: {
              required,
              maxVal: maxValue(500000)
          }
        },
        computed: {
            ...mapGetters([
                'username'
            ])
        },
        methods: {
            onFileSelect(event) {
                const files = event.target.files;
                if (files.length > 0) {
                    this.image = files.item(0);
                }
            },
            onSubmit() {
                const formData = new FormData();
                formData.append('product_name', this.productName);
                formData.append('description', this.description);
                formData.append('price', this.price);
                formData.append('image', this.image);
                formData.append('username', this.username);
                axios.post('http://localhost:8000/api/addProduct.php', formData)
                    .then((res) => {
                        console.log(res.data);
                        this.$router.replace('/shop')
                    }).catch((err) => {
                    console.log(err);
                });
            }
        }
    }
</script>